# frozen_string_literal: true

require_relative 'fraction'

class FractionList
  attr_reader :fractions

  def initialize
    @fractions = []
  end

  def read_from_file(file_name)
    strings = File.readlines(file_name)
    new_fractions = strings.map do |string|
      parts = string.split('/').map(&:strip).map(&:to_i)
      Fraction.new(*parts)
    end
    @fractions.concat(new_fractions)
  end

  def summs
    results = []
    @fractions.each_with_index do |first, index|
      @fractions.slice(index + 1, @fractions.size).each do |second|
        results.append(first.sum(second))
      end
    end
    results
  end
end
